import 'package:flutter/material.dart';
import 'package:nova_utils/nova_utils.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Welcome to Flutter',
      debugShowCheckedModeBanner: false,
      home: Main(),
    );
  }
}

class Main extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<Main> {
  @override
  void initState() {
    super.initState();
    showprivacyTest();
  }
  void showprivacyTest() async{
    await NovaUtils.setUserAndPrivacyAgreement("file:///android_asset/user.html","file:///android_asset/privacy.html");
    NovaUtils.setStartAndroidApp().then((value) => print("隐私协议结果$value"));
  }

  final TextEditingController _controller =
      new TextEditingController(text: "test");

  final TextEditingController _controllerValue =
      new TextEditingController(text: "默认的KeyValue");

  final TextEditingController kvKey = new TextEditingController(text: "app_test");

  var kvValue = "空";

  void update() async {
    await NovaUtils.checkUpdate();
  }

  void rateApp() async {
    await NovaUtils.rateApp();
  }

  void showPrivacy() async {
    await NovaUtils.showPrivacy();
  }

  void getOtherData() async {
   var text = await NovaUtils.getConfigParams(kvKey.value.text);

   if(text == null){
     print("查询的结果为null");
   }else{
     kvValue = text;
   }


   setState(() {
     
     
   });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Plugin example app'),
      ),
      body: Column(
        children: <Widget>[
          Row(
            mainAxisAlignment: MainAxisAlignment.center,
            children: <Widget>[
              FlatButton(
                child: Text('保存KEYChain'),
                onPressed: () {
                  print("保存");
                  Map<String, String> params = {
                    _controller.value.text: _controllerValue.value.text,
                  };
                  NovaUtils.setKeyChanValue(params);
                },
              ),
              FlatButton(
                child: Text('获取KEYChain'),
                onPressed: () {
                  List<String> paramsName = [_controller.value.text];
                  NovaUtils.getKeyChainValue(paramsName).then((value) {
                    var value2 = value[_controller.value.text];
                    _controllerValue.text = value2;
                    setState(() {});
                  });
                },
              ),
              FlatButton(
                child: Text('提示更新'),
                onPressed: () {
                  update();
                },
              ),
            ],
          ),
          Row(
            children: <Widget>[
              FlatButton(
                child: Text('好评'),
                onPressed: () {
                  rateApp();
                },
              ),
              FlatButton(
                child: Text('显示隐私政策'),
                onPressed: () {
                  showPrivacy();
                },
              ),
            ],
          ),
          Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: <Widget>[
              Text("KeyChain"),
              Center(
                child: TextFormField(
                  controller: _controller,
                ),
              ),
              Text("KeyChainValue"),
              Center(
                child: TextFormField(
                  controller: _controllerValue,
                ),
              ),
            ],
          ),
          Divider(),
          Column(
            children: <Widget>[
              FlatButton(onPressed: getOtherData, child: Text("获取ohterdata")),
              TextFormField(
                controller: kvKey,
              ),
              Text(kvValue)
            ],
          )
        ],
      ),
    );
  }
}
